Index: src/Actions/AtomAction/RemoveAction.cpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AtomAction/RemoveAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * RemoveAction.cpp
@@ -6,13 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AtomAction/RemoveAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
+#include "AtomicInfo.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -22,66 +33,77 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AtomAction/RemoveAction.hpp"
 
-const char AtomRemoveAction::NAME[] = "remove-atom";
-
-AtomRemoveAction::AtomRemoveAction() :
-  Action(NAME)
-{}
-
-AtomRemoveAction::~AtomRemoveAction()
-{}
-
-void AtomRemove() {
-  ActionRegistry::getInstance().getActionByName(AtomRemoveAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* AtomRemoveAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "RemoveAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr AtomRemoveAction::performCall() {
   atom *first = NULL;
 
-  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
+  // create undo state
+  std::vector<AtomicInfo> Walkers;
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    Walkers.push_back(AtomicInfo(*(iter->second)));
+  }
+  AtomRemoveState *UndoState = new AtomRemoveState(Walkers, params);
+
+  // remove all selected atoms
+//  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
   for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
     first = iter->second;
     DoLog(1) && (Log() << Verbose(1) << "Removing atom " << first->getId() << "." << endl);
-    // TODO: this is not necessary when atoms and their storing to file are handled by the World
-    // simply try to erase in every molecule found
-    for (std::vector<molecule *>::iterator iter = molecules.begin();iter != molecules.end(); ++iter) {
-      (*iter)->erase(first);
-    }
+//    // TODO: this is not necessary when atoms and their storing to file are handled by the World
+//    // simply try to erase in every molecule found
+//    for (std::vector<molecule *>::iterator iter = molecules.begin();iter != molecules.end(); ++iter) {
+//      (*iter)->erase(first);
+//    }
     World::getInstance().destroyAtom(first);
   }
-  return Action::success;
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr AtomRemoveAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomRemoveState *state = assert_cast<AtomRemoveState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  size_t i=0;
+  for (; i<state->Walkers.size(); ++i) {
+    // re-create the atom
+    DoLog(1) && (Log() << Verbose(1) << "Re-adding atom " << state->Walkers[i].getId() << "." << endl);
+    atom *Walker = World::getInstance().createAtom();
+    if (!state->Walkers[i].setAtom(*Walker)) {
+      DoeLog(1) && (eLog() << Verbose(1) << "Failed to set id." << endl);
+      World::getInstance().destroyAtom(Walker);
+      break;
+    }
+  }
+  if (i<state->Walkers.size()) {
+    // remove all previous ones, too
+    for (size_t j=0;j<i;++j)
+      World::getInstance().destroyAtom(state->Walkers[j].getId());
+    // and announce the failure of the undo
+    return Action::failure;
+  }
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomRemoveAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomRemoveState *state = assert_cast<AtomRemoveState*>(_state.get());
+
+  // simple remove again all previously added atoms
+  for (size_t i=0; i<state->Walkers.size(); ++i) {
+    DoLog(1) && (Log() << Verbose(1) << "Re-removing atom " << state->Walkers[i].getId() << "." << endl);
+    World::getInstance().destroyAtom(state->Walkers[i].getId());
+  }
+
+  return Action::state_ptr(_state);
 }
 
 bool AtomRemoveAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomRemoveAction::shouldUndo() {
-  return false;
+  return true;
 }
 
@@ -89,2 +111,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AtomAction/RemoveAction.def
===================================================================
--- src/Actions/AtomAction/RemoveAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/RemoveAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * RemoveAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<AtomicInfo>)
+#define statereferences (Walkers)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Atom
+#define ACTIONNAME Remove
+#define TOKEN "remove-atom"
+
Index: src/Actions/AtomAction/RemoveAction.hpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AtomAction/RemoveAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void AtomRemove();
-
-class AtomRemoveAction : public Action {
-  friend void AtomRemove();
-
-public:
-  AtomRemoveAction();
-  virtual ~AtomRemoveAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog*);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "RemoveAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* REMOVEACTION_HPP_ */
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,104 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * RotateAroundOriginByAngleAction.cpp
+ *
+ *  Created on: Aug 06, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "molecule.hpp"
+
+
+#include <cmath>
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/AtomAction/RotateAroundOriginByAngleAction.hpp"
+
+// and construct the stuff
+#include "RotateAroundOriginByAngleAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr AtomRotateAroundOriginByAngleAction::performCall() {
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  // check whether Axis is valid
+  if (params.Axis.IsZero())
+    return Action::failure;
+
+  // convert from degrees to radian
+  params.angle *= M_PI/180.;
+
+  // Creation Line that is the rotation axis
+  Line RotationAxis(Vector(0.,0.,0.), params.Axis);
+
+  DoLog(0) && (Log() << Verbose(0) << "Rotate around origin by " << params.angle << " radian, axis from origin to " << params.Axis << "." << endl);
+  // TODO: use AtomSet::rotate?
+  for (std::vector<atom *>::iterator iter = selectedAtoms.begin(); iter != selectedAtoms.end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), params.angle));
+  }
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+  return Action::state_ptr(new AtomRotateAroundOriginByAngleState(World::getInstance().getSelectedAtoms(), params));
+}
+
+Action::state_ptr AtomRotateAroundOriginByAngleAction::performUndo(Action::state_ptr _state) {
+  AtomRotateAroundOriginByAngleState *state = assert_cast<AtomRotateAroundOriginByAngleState*>(_state.get());
+
+  // Creation Line that is the rotation axis
+  Line RotationAxis(Vector(0.,0.,0.), state->params.Axis);
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), -state->params.angle));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr AtomRotateAroundOriginByAngleAction::performRedo(Action::state_ptr _state){
+  AtomRotateAroundOriginByAngleState *state = assert_cast<AtomRotateAroundOriginByAngleState*>(_state.get());
+
+  // Creation Line that is the rotation axis
+  Line RotationAxis(Vector(0.,0.,0.), state->params.Axis);
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), state->params.angle));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+bool AtomRotateAroundOriginByAngleAction::canUndo() {
+  return true;
+}
+
+bool AtomRotateAroundOriginByAngleAction::shouldUndo() {
+  return true;
+}
+
+const string AtomRotateAroundOriginByAngleAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.def
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * RotateAroundOriginByAngleAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (double) (Vector)
+#define paramtokens (AtomRotateAroundOriginByAngleAction::NAME) ("position")
+#define paramreferences (angle) (Axis)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Atom
+#define ACTIONNAME RotateAroundOriginByAngle
+#define TOKEN "rotate-origin"
+
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.hpp
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * RotateAroundOriginByAngleAction.hpp
+ *
+ *  Created on: Aug 06, 2010
+ *      Author: heber
+ */
+
+#ifndef ROTATEAROUNDORIGINBYANGLEACTION_HPP
+#define ROTATEAROUNDORIGINBYANGLEACTION_HPP
+
+#include "Actions/Action.hpp"
+
+#include "RotateAroundOriginByAngleAction.def"
+#include "Action_impl_header.hpp"
+
+#endif // ROTATEAROUNDORIGINBYANGLEACTION_HPP
Index: src/Actions/AtomAction/TranslateAction.cpp
===================================================================
--- src/Actions/AtomAction/TranslateAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/TranslateAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,94 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * TranslateAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Log.hpp"
+#include "atom.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/AtomAction/TranslateAction.hpp"
+
+// and construct the stuff
+#include "TranslateAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr AtomTranslateAction::performCall() {
+  Box &domain = World::getInstance().getDomain();
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  // TODO: use AtomSet::translate
+  for (std::vector<atom *>::iterator iter = selectedAtoms.begin(); iter != selectedAtoms.end(); ++iter) {
+    *(*iter) += params.x;
+    if (params.periodic)
+      (*iter)->setPosition(domain.WrapPeriodically((*iter)->getPosition()));
+  }
+
+  return Action::state_ptr(new AtomTranslateState(selectedAtoms, params));
+}
+
+Action::state_ptr AtomTranslateAction::performUndo(Action::state_ptr _state) {
+  AtomTranslateState *state = assert_cast<AtomTranslateState*>(_state.get());
+  Box &domain = World::getInstance().getDomain();
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    *(*iter) -= state->params.x;
+    if (state->params.periodic)
+      (*iter)->setPosition(domain.WrapPeriodically((*iter)->getPosition()));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr AtomTranslateAction::performRedo(Action::state_ptr _state){
+  AtomTranslateState *state = assert_cast<AtomTranslateState*>(_state.get());
+  Box &domain = World::getInstance().getDomain();
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    *(*iter) += state->params.x;
+    if (state->params.periodic)
+      (*iter)->setPosition(domain.WrapPeriodically((*iter)->getPosition()));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+bool AtomTranslateAction::canUndo() {
+  return true;
+}
+
+bool AtomTranslateAction::shouldUndo() {
+  return true;
+}
+
+const string AtomTranslateAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/AtomAction/TranslateAction.def
===================================================================
--- src/Actions/AtomAction/TranslateAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/TranslateAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * TranslateAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Vector) (bool)
+#define paramtokens (AtomTranslateAction::NAME) ("periodic")
+#define paramreferences (x) (periodic)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Atom
+#define ACTIONNAME Translate
+#define TOKEN "translate-atoms"
+
Index: src/Actions/AtomAction/TranslateAction.hpp
===================================================================
--- src/Actions/AtomAction/TranslateAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/TranslateAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * TranslateAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef TRANSLATEACTION_HPP
+#define TRANSLATEACTION_HPP
+
+#include "Actions/Action.hpp"
+
+#include "TranslateAction.def"
+#include "Action_impl_header.hpp"
+
+#endif // TRANSLATEACTION_HPP
Index: src/Actions/Calculation.hpp
===================================================================
--- src/Actions/Calculation.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/Calculation.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -64,4 +64,5 @@
   virtual T* doCalc()=0;
 private:
+  virtual void getParametersfromValueStorage();
   virtual Action::state_ptr performCall();
   virtual Action::state_ptr performUndo(Action::state_ptr);
Index: src/Actions/Calculation_impl.hpp
===================================================================
--- src/Actions/Calculation_impl.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/Calculation_impl.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -27,4 +27,8 @@
 
 // methods inherited from Action
+
+template<typename T>
+void Calculation<T>::getParametersfromValueStorage()
+{}
 
 template<typename T>
Index: src/Actions/CommandAction/BondLengthTableAction.cpp
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/BondLengthTableAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,87 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * BondLengthTableAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "bondgraph.hpp"
+#include "config.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/CommandAction/BondLengthTableAction.hpp"
+
+// and construct the stuff
+#include "BondLengthTableAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr CommandBondLengthTableAction::performCall() {
+  ostringstream usage;
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  DoLog(0) && (Log() << Verbose(0) << "Using " << params.BondGraphFileName << " as bond length table." << endl);
+  config *configuration = World::getInstance().getConfig();
+  if (configuration->BG == NULL) {
+    configuration->BG = new BondGraph(configuration->GetIsAngstroem());
+    if ((!params.BondGraphFileName.empty()) && (configuration->BG->LoadBondLengthTable(params.BondGraphFileName))) {
+      DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
+      return Action::success;
+    } else {
+      DoeLog(1) && (eLog()<< Verbose(1) << "Bond length table loading failed." << endl);
+      return Action::failure;
+    }
+  } else {
+    DoLog(0) && (Log() << Verbose(0) << "Bond length table already present." << endl);
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandBondLengthTableAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandBondLengthTableAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandBondLengthTableAction::canUndo() {
+  return false;
+}
+
+bool CommandBondLengthTableAction::shouldUndo() {
+  return false;
+}
+
+const string CommandBondLengthTableAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/CommandAction/BondLengthTableAction.def
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/BondLengthTableAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * BondLengthTableAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (CommandBondLengthTableAction::NAME)
+#define paramreferences (BondGraphFileName)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Command
+#define ACTIONNAME BondLengthTable
+#define TOKEN "bond-table"
+
Index: src/Actions/CommandAction/BondLengthTableAction.hpp
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/BondLengthTableAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * BondLengthTableAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef BONDLENGTHTABLEACTION_HPP_
+#define BONDLENGTHTABLEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "BondLengthTableAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* BONDLENGTHTABLEACTION_HPP_ */
Index: src/Actions/CommandAction/ElementDbAction.cpp
===================================================================
--- src/Actions/CommandAction/ElementDbAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/ElementDbAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,88 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ElementDbAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "config.hpp"
+#include "Helpers/Log.hpp"
+#include "periodentafel.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/CommandAction/ElementDbAction.hpp"
+
+// and construct the stuff
+#include "ElementDbAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr CommandElementDbAction::performCall() {
+  ostringstream usage;
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  // get the path
+  // TODO: Make databasepath a std::string
+  config *configuration = World::getInstance().getConfig();
+  strcpy(configuration->databasepath, params.databasepath.c_str());
+
+  // load table
+  periodentafel *periode = World::getInstance().getPeriode();
+  if (periode->LoadPeriodentafel(configuration->databasepath)) {
+    DoLog(0) && (Log() << Verbose(0) << "Element list loaded successfully." << endl);
+    //periode->Output();
+    return Action::success;
+  } else {
+    DoLog(0) && (Log() << Verbose(0) << "Element list loading failed." << endl);
+    return Action::failure;
+  }
+
+}
+
+Action::state_ptr CommandElementDbAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandElementDbAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandElementDbAction::canUndo() {
+  return false;
+}
+
+bool CommandElementDbAction::shouldUndo() {
+  return false;
+}
+
+const string CommandElementDbAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/CommandAction/ElementDbAction.def
===================================================================
--- src/Actions/CommandAction/ElementDbAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/ElementDbAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * ElementDbAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (CommandElementDbAction::NAME)
+#define paramreferences (databasepath)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Command
+#define ACTIONNAME ElementDb
+#define TOKEN "element-db"
+
Index: src/Actions/CommandAction/ElementDbAction.hpp
===================================================================
--- src/Actions/CommandAction/ElementDbAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/ElementDbAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * ElementDbAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ELEMENTDBACTION_HPP_
+#define ELEMENTDBACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "ElementDbAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* ELEMENTDBACTION_HPP_ */
Index: src/Actions/CommandAction/FastParsingAction.cpp
===================================================================
--- src/Actions/CommandAction/FastParsingAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/CommandAction/FastParsingAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,90 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FastParsingAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "config.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/CommandAction/FastParsingAction.hpp"
+
+// and construct the stuff
+#include "FastParsingAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr CommandFastParsingAction::performCall() {
+  config *configuration = World::getInstance().getConfig();
+  bool oldvalue = configuration->FastParsing;
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  configuration->FastParsing = params.fastparsing;
+  if (configuration->FastParsing)
+    DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+  return Action::state_ptr(new CommandFastParsingState(oldvalue, params));
+}
+
+Action::state_ptr CommandFastParsingAction::performUndo(Action::state_ptr _state) {
+  CommandFastParsingState *state = assert_cast<CommandFastParsingState*>(_state.get());
+
+  config *configuration = World::getInstance().getConfig();
+  configuration->FastParsing = state->oldvalue;
+  if (configuration->FastParsing)
+    DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr CommandFastParsingAction::performRedo(Action::state_ptr _state){
+  CommandFastParsingState *state = assert_cast<CommandFastParsingState*>(_state.get());
+
+  config *configuration = World::getInstance().getConfig();
+  configuration->FastParsing = state->params.fastparsing;
+  if (configuration->FastParsing)
+    DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+
+  return Action::state_ptr(_state);
+}
+
+bool CommandFastParsingAction::canUndo() {
+  return true;
+}
+
+bool CommandFastParsingAction::shouldUndo() {
+  return true;
+}
+
+const string CommandFastParsingAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
